export interface PulseResponse<DataType = any> {
    data: DataType;
    timedout?: boolean;
    status: number;
    raw?: Response;
    type?: string;
}
export interface APIConfig {
    options: RequestInit;
    baseURL?: string;
    path?: string;
    timeout?: number;
    requestIntercept?: Function;
    responseIntercept?: Function;
}
export declare class API {
    config: APIConfig;
    constructor(config?: APIConfig);
    /**
     * Override API config and request options. Returns a modified instance this API with overrides applied.
     * @param config - O
     */
    with(config: APIConfig): API;
    get(endpoint: string): Promise<PulseResponse<any>>;
    post(endpoint: string, payload?: any): Promise<PulseResponse<any>>;
    put(endpoint: string, payload?: any): Promise<PulseResponse<any>>;
    patch(endpoint: string, payload?: any): Promise<PulseResponse<any>>;
    delete(endpoint: string, payload?: any): Promise<PulseResponse<any>>;
    private send;
    static cloneDefaultConfig(config: APIConfig): APIConfig;
}
export default API;
//# sourceMappingURL=api.d.ts.map