import { Pulse } from '../pulse';
import { State, Collection, DefaultDataItem } from '../internal';
export declare type PrimaryKey = string | number;
export declare type GroupName = string | number;
export declare type Index = Array<PrimaryKey>;
export declare type InstanceContext = (() => Collection) | (() => Pulse);
interface GroupConfig {
    name?: GroupName;
    provisional?: boolean;
    lazyBuild?: boolean;
}
export declare class Group<DataType = DefaultDataItem> extends State<Array<PrimaryKey>> {
    private collection;
    private _output;
    private _preciseIndex;
    private _missingPrimaryKeys;
    private _trackedIndexChanges;
    private _outdated;
    private computedFunc?;
    provisional: boolean;
    get index(): Array<PrimaryKey>;
    get size(): number;
    get output(): Array<DataType>;
    constructor(context: InstanceContext, initialIndex?: Array<PrimaryKey>, config?: GroupConfig);
    build(): any[];
    private getCollectionData;
    private renderData;
    has(primaryKey: PrimaryKey): boolean;
    compute(func: (data: DataType) => DataType): void;
    add(primaryKeyOrKeys: PrimaryKey | PrimaryKey[], options?: GroupAddOptions): this;
    remove(primaryKey: PrimaryKey, options?: GroupRemoveOptions): this;
    private trackChange;
    rebuildOne(primaryKey: PrimaryKey): this;
}
export default Group;
export interface GroupRemoveOptions {
    softRebuild?: boolean;
}
export interface GroupAddOptions {
    atIndex?: number;
    softRebuild?: boolean;
    method?: 'unshift' | 'push';
    overwrite?: boolean;
}
//# sourceMappingURL=group.d.ts.map