import { Pulse } from './pulse';
export declare type EventPayload = any;
export declare type EventCallbackFunc<P = EventPayload> = (payload: P) => void;
export declare type CreateEventFunc = <P = EventPayload>(config?: EventConfig<P>) => Event<P>;
export declare type EventsObjFunc = (createEventFunc: CreateEventFunc) => {
    [key: string]: Event;
};
export interface EventConfig<P = EventPayload> {
    name?: string;
    maxSubs?: number;
    enabled?: boolean;
    disableAfterUses?: number;
    throttle?: number;
    queue?: boolean;
}
export declare class Event<P = EventPayload> {
    instance: () => Pulse;
    config: EventConfig<P>;
    private callbacks;
    private uses;
    private currentTimeout;
    private queue;
    payload: P;
    private onNextCallback;
    constructor(instance: () => Pulse, config?: EventConfig<P>);
    on(callback: EventCallbackFunc<P>): () => void;
    emit(payload?: P): void;
    disable(): void;
    onNext(callback: (payload?: P) => any): void;
    private emitter;
    private unsub;
    private handleThrottle;
}
//# sourceMappingURL=event.d.ts.map