import Pulse from './pulse';
import { State, Dep, Computed, DefaultDataItem, CollectionConfig, Collection, FuncType, EventPayload, EventConfig, Event } from './internal';
import { route } from './route';
export declare const instance: Pulse;
export declare function state<T>(initialState: T, deps?: Array<Dep>): State<T>;
export declare function state<T>(computedFunc: () => T, deps?: Array<State>): Computed<T>;
export declare function collection<DataType extends DefaultDataItem = DefaultDataItem>(config?: CollectionConfig): Collection<DataType, {}, {}>;
export declare function action<T extends FuncType>(func: T): import("./action").HigherOrderFunc<T>;
export declare function event<P = EventPayload>(config?: EventConfig<P>): Event<P>;
export { route };
export declare const setCore: <CoreType>(core?: CoreType) => CoreType;
export declare const nextPulse: (callback: () => any) => void;
export declare const track: (changeFunc: () => void) => import("./tracker").Tracker;
export declare const batch: (batchFunc: () => void) => void;
export declare const setStorage: (config: import("./storage").StorageConfig) => void;
export declare const configure: (config: import("./pulse").PulseConfig) => void;
//# sourceMappingURL=instance.d.ts.map