"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.configure = exports.setStorage = exports.batch = exports.track = exports.nextPulse = exports.setCore = exports.route = exports.event = exports.action = exports.collection = exports.state = exports.instance = void 0;
const pulse_1 = __importDefault(require("./pulse"));
const internal_1 = require("./internal");
const route_1 = require("./route");
Object.defineProperty(exports, "route", { enumerable: true, get: function () { return route_1.route; } });
// create global instance
exports.instance = new pulse_1.default();
function state(value, deps) {
    if (typeof value == 'function') {
        return new internal_1.Computed(() => exports.instance, value, deps);
    }
    return new internal_1.State(() => exports.instance, value, deps);
}
exports.state = state;
function collection(config = {}) {
    const collection = new internal_1.Collection(() => exports.instance, config);
    return collection;
}
exports.collection = collection;
function action(func) {
    return new internal_1.Action(() => exports.instance, func).func();
}
exports.action = action;
function event(config) {
    return new internal_1.Event(() => exports.instance, config);
}
exports.event = event;
exports.setCore = (core) => exports.instance.core(core);
exports.nextPulse = exports.instance.nextPulse;
exports.track = exports.instance.track;
exports.batch = exports.instance.batch;
exports.setStorage = exports.instance.setStorage;
exports.configure = exports.instance.configure;
//# sourceMappingURL=instance.js.map