import { Pulse } from './pulse';
export interface IntegrationConfig<T> {
    name?: any;
    foreignInstance?: T;
    updateMethod?: (componentInstance: any, updateProperties: any) => void;
    onPulseReady?: (pulseInstance: Pulse) => void;
    onCoreReady?: (pulseInstance: Pulse) => void;
}
export declare class Integration<T = any> {
    config: IntegrationConfig<T>;
    ready?: boolean;
    constructor(config: IntegrationConfig<T>);
}
export declare class Integrations {
    instance: () => Pulse;
    loaded: {
        [key: string]: Integration;
    };
    loadedSet: Set<Integration>;
    constructor(instance: () => Pulse);
    use(integration: Integration): void;
    pulseReady(): void;
    coreReady(): void;
    update(componentInstance: any, updateProperties: any): void;
}
//# sourceMappingURL=integrate.d.ts.map