"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Integrations = exports.Integration = void 0;
const pulse_1 = require("./pulse");
// import this into integration modules to create a
class Integration {
    constructor(config) {
        this.config = config;
    }
}
exports.Integration = Integration;
class Integrations {
    constructor(instance) {
        this.instance = instance;
        this.loaded = {};
        this.loadedSet = new Set();
        if (pulse_1.Pulse.initialIntegrations)
            pulse_1.Pulse.initialIntegrations.forEach(int => this.use(int));
    }
    use(integration) {
        if (!(integration instanceof Integration) || !integration.config.name)
            throw 'Pulse Error: Not a valid integration object';
        this.loaded[integration.config.name] = integration;
        this.loadedSet.add(integration);
    }
    // Event runners
    pulseReady() {
        this.loadedSet.forEach(integration => integration.config.onPulseReady && integration.config.onPulseReady(this.instance()));
    }
    coreReady() {
        this.loadedSet.forEach(integration => integration.config.onCoreReady && integration.config.onCoreReady(this.instance()));
    }
    update(componentInstance, updateProperties) {
        this.loadedSet.forEach(integration => integration.config.updateMethod && integration.config.updateMethod(componentInstance, updateProperties));
    }
}
exports.Integrations = Integrations;
//# sourceMappingURL=integrate.js.map