import { State, Computed, Collection, SubController, Runtime, Storage, StorageConfig, Integrations, Integration, Tracker, HistoryItem } from './internal';
import StatusTracker from './status';
export interface PulseConfig {
    computedDefault?: any;
    waitForMount?: boolean;
    storage?: StorageConfig;
    logJobs?: boolean;
    noCore?: boolean;
    globalHistory?: boolean;
}
export declare const defaultConfig: PulseConfig;
interface ErrorObject {
    code: number;
    message: string;
    action: Function;
    raw: any;
}
export declare class Pulse {
    ready: boolean;
    runtime: Runtime;
    status: StatusTracker;
    storage: Storage;
    controllers: {
        [key: string]: any;
    };
    subController: SubController;
    errorHandlers: Set<(error: ErrorObject) => void>;
    history: HistoryItem[];
    integrations: Integrations;
    static initialIntegrations: Integration[];
    _core: {
        [key: string]: any;
    };
    _computed: Set<Computed>;
    _state: Set<State>;
    _collections: Set<Collection>;
    private nonce;
    config: PulseConfig;
    constructor();
    onCoreReady(core?: {
        [key: string]: any;
    }): void;
    core<CoreType>(core?: CoreType): CoreType;
    with(integration: Integration): this;
    nextPulse(callback: () => any): void;
    track(changeFunc: () => void): Tracker;
    batch(batchFunc: () => void): void;
    setStorage(config: StorageConfig): void;
    createError(error: any, info?: {
        fromAction?: any;
    }): void;
    /**
     * Global reference to the first pulse instance created this runtime
     */
    private globalBind;
    getNonce(): number;
    configure(config: PulseConfig): void;
}
export default Pulse;
//# sourceMappingURL=pulse.d.ts.map