import { Pulse } from './pulse';
import { State } from './internal';
export interface StorageConfig {
    type?: 'custom' | 'localStorage';
    prefix?: string;
    async?: boolean;
    get?: any;
    set?: any;
    remove?: any;
    watch?: boolean;
}
export declare class Storage {
    private instance;
    config: StorageConfig;
    private storageReady;
    persistedState: Set<State>;
    constructor(instance: () => Pulse, config: StorageConfig);
    get(key: string): any;
    set(key: string, value: any): void;
    remove(key: string): void;
    private getKey;
    private extractKey;
    handleStatePersist(state: State, key: string): void;
    private getLocalStorage;
}
export default Storage;
export declare function persist(items: Array<State>): void;
//# sourceMappingURL=storage.d.ts.map